Magellan Linux

Diff of /branches/mage-next/src/mage4.functions.sh.in

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 1620 by niro, Tue Jan 10 15:47:08 2012 UTC revision 1658 by niro, Sat Jan 14 00:00:53 2012 UTC
# Line 66  mchecksum() Line 66  mchecksum()
66   case ${method} in   case ${method} in
67   md5) cmd="md5sum" ;;   md5) cmd="md5sum" ;;
68   sha256) cmd="sha256sum" ;;   sha256) cmd="sha256sum" ;;
69   *) die "mchecksum(): unkown method '${method}'" ;;   *) die "mchecksum(): unknown method '${method}'" ;;
70   esac   esac
71    
72   if [[ -d ${rundir} ]]   if [[ -d ${rundir} ]]
73   then   then
74   pushd ${rundir} &> /dev/null   pushd ${rundir} &> /dev/null
75   ${cmd} -c ${file} &> /dev/null   # be verbose here
76     ${cmd} -c ${file} #&> /dev/null
77   retval="$?"   retval="$?"
78   popd &> /dev/null   popd &> /dev/null
79   else   else
# Line 82  mchecksum() Line 83  mchecksum()
83   return "${retval}"   return "${retval}"
84  }  }
85    
86    mcheckemptydir()
87    {
88     local dir="$1"
89     local retval=1
90    
91     if [[ ! -d ${dir} ]]
92     then
93     echo "mcheckemptydir(): '${dir}' is not a directory!"
94     retval=3
95     else
96     shopt -s nullglob dotglob
97     files=( ${dir}/* )
98     (( ${#files[*]} )) || retval=0
99     shopt -u nullglob dotglob
100     fi
101    
102     return ${retval}
103    }
104    
105  unpack_packages()  unpack_packages()
106  {  {
107   local list="$@"   local list="$@"
# Line 1401  mdownload() Line 1421  mdownload()
1421   real_uris="$(convertmirrors ${uri})"   real_uris="$(convertmirrors ${uri})"
1422    
1423   # verbose or not   # verbose or not
1424   mqueryfeature "!verbose" && wget_opts="--quiet"   mqueryfeature "!verbose" && wget_opts+=" --quiet"
1425    
1426   # filter wget options if busybox was found   # filter wget options if busybox was found
1427   wget_opts="$(busybox_filter_wget_options ${WGET_FETCH_OPTIONS})"   wget_opts+=" $(busybox_filter_wget_options ${WGET_FETCH_OPTIONS})"
1428    
1429   # create outputdir   # create outputdir
1430   [[ ! -d ${outputdir} ]] && install -d "${outputdir}"   [[ ! -d ${outputdir} ]] && install -d "${outputdir}"
# Line 1579  syncmage_tarball() Line 1599  syncmage_tarball()
1599   else   else
1600   echo -ne "${COLBLUE} --- ${COLDEFAULT}"   echo -ne "${COLBLUE} --- ${COLDEFAULT}"
1601   echo -n "checking md5sum... "   echo -n "checking md5sum... "
1602   ( cd ${temp}; md5sum -c ${latest_md5} ) || die "md5 for ${latest_tarball} failed"   mchecksum --rundir "${temp}" --file "${latest_md5}" --method md5 || die "md5 for ${latest_tarball} failed"
1603   fi   fi
1604    
1605   if [[ -d ${MAGEDIR} ]]   if [[ -d ${MAGEDIR} ]]
1606   then   then
1607   echo -ne "${COLBLUE} --- ${COLDEFAULT}"   echo -ne "${COLBLUE} --- ${COLDEFAULT}"
1608   echo "cleaning old mage-tree ${MAGEDIR}..."   echo "cleaning old mage-tree ${MAGEDIR}..."
1609   rm -rf ${MAGEDIR}   # honor mountpoints and empty dirs
1610     if mountpoint -q ${MAGEDIR}
1611     then
1612     if ! mcheckemptydir ${MAGEDIR}
1613     then
1614     find ${MAGEDIR} -mindepth 1 -maxdepth 1 | xarg --no-run-if-empty rm -r
1615     fi
1616     else
1617     rm -rf ${MAGEDIR}
1618     fi
1619   fi   fi
1620    
1621   if need_busybox_support tar   if need_busybox_support tar
# Line 1645  xtitleclean() Line 1674  xtitleclean()
1674  }  }
1675    
1676    
1677  # cuts full pathnames or versionized names down to basename  # unused?
1678  choppkgname()  #
1679  {  # # cuts full pathnames or versionized names down to basename
1680   #we want this only if full name was used  # choppkgname()
1681   if [ -n "$(echo ${MAGENAME}|fgrep .mage)" ]  # {
1682   then  # #we want this only if full name was used
1683   #cuts ARCH and PBUILD  # if [ -n "$(echo ${MAGENAME}|fgrep .mage)" ]
1684   #ARCH comes from ${MAGERC}  # then
1685   MAGENAME=$(echo ${MAGENAME} |sed -e "s:-${ARCH}-r*.::g")  # #cuts ARCH and PBUILD
1686    # #ARCH comes from ${MAGERC}
1687    # MAGENAME=$(echo ${MAGENAME} |sed -e "s:-${ARCH}$(print_distrotag)-r*.::g")
1688    #
1689    # #cuts version number
1690    # MAGENAME=$(basename ${MAGENAME%-*} .mage)
1691    # fi
1692    # }
1693    
  #cuts version number  
  MAGENAME=$(basename ${MAGENAME%-*} .mage)  
  fi  
 }  
1694    
1695  # get_categorie $PNAME, returns CATEGORIE  # get_categorie $PNAME, returns CATEGORIE
1696  # $1=pname  # $1=pname
# Line 2759  md5sum_packages() Line 2791  md5sum_packages()
2791   then   then
2792   echo -ne "${COLBLUE} *** ${COLDEFAULT}"   echo -ne "${COLBLUE} *** ${COLDEFAULT}"
2793   echo -ne "checking md5sum (${count_current}/${count_total}): "   echo -ne "checking md5sum (${count_current}/${count_total}): "
2794   ( cd ${PKGDIR}; md5sum -c ${md5file}) || die "md5 for ${pkgfile} failed"   mchecksum --rundir "${PKGDIR}" --file "${md5file}" --method md5 || die "md5 for ${pkgfile} failed"
2795   else   else
2796   echo -ne "${COLBLUE} --- ${COLDEFAULT}"   echo -ne "${COLBLUE} --- ${COLDEFAULT}"
2797   echo -e "!! no md5sum file found for ${pkgfile} :("   echo -e "!! no md5sum file found for ${pkgfile} :("
# Line 2999  pkgsearch() Line 3031  pkgsearch()
3031   local state   local state
3032   local descriptiom   local descriptiom
3033   local homepage   local homepage
3034     local license
3035   local i   local i
3036   local all_installed   local all_installed
3037   local ipver   local ipver
# Line 3035  pkgsearch() Line 3068  pkgsearch()
3068   state="$(get_value_from_magefile STATE ${magefile})"   state="$(get_value_from_magefile STATE ${magefile})"
3069   description="$(get_value_from_magefile DESCRIPTION ${magefile})"   description="$(get_value_from_magefile DESCRIPTION ${magefile})"
3070   homepage="$(get_value_from_magefile HOMEPAGE ${magefile})"   homepage="$(get_value_from_magefile HOMEPAGE ${magefile})"
3071     license="$(get_value_from_magefile LICENSE ${magefile})"
3072    
3073   # all installed   # all installed
3074   for i in $(get_uninstall_candidates --pname ${pname} --pcat ${pcat})   for i in $(get_uninstall_candidates --pname ${pname} --pcat ${pcat})
3075   do   do
3076   ipver="$(magename2pver ${i})"   ipver="$(magename2pver ${i})"
3077   ipbuild="$(magename2pbuild ${i})"   ipbuild="$(magename2pbuild ${i})"
3078    
3079   if [[ -z ${all_installed} ]]   if [[ -z ${all_installed} ]]
3080   then   then
3081   all_installed="${ipver}-${ipbuild}"   all_installed="${ipver}-${ipbuild}"
# Line 3050  pkgsearch() Line 3084  pkgsearch()
3084   fi   fi
3085   done   done
3086   [[ -z ${all_installed} ]] && all_installed="none"   [[ -z ${all_installed} ]] && all_installed="none"
3087    
3088   case ${state} in   case ${state} in
3089   stable) state=${COLGREEN}"[s] ";;   stable) state=${COLGREEN}"[s] ";;
3090   testing) state=${COLYELLOW}"[t] ";;   testing) state=${COLYELLOW}"[t] ";;
# Line 3095  EOF Line 3129  EOF
3129   echo "      Installed versions: ${all_installed}"   echo "      Installed versions: ${all_installed}"
3130   echo "      Description: ${description}"   echo "      Description: ${description}"
3131   echo "      Homepage: ${homepage}"   echo "      Homepage: ${homepage}"
3132     if [[ ! -z ${license} ]]
3133     then
3134     echo "      License:  ${license}"
3135     fi
3136   echo "      Depends: ${deps}"   echo "      Depends: ${deps}"
3137   echo "      SDepends: ${sdeps}"   echo "      SDepends: ${sdeps}"
3138   echo   echo
# Line 3285  known_mage_feature() Line 3323  known_mage_feature()
3323   ccache|!ccache) retval=0 ;;   ccache|!ccache) retval=0 ;;
3324   check|!check) retval=0 ;;   check|!check) retval=0 ;;
3325   compressdoc|!compressdoc) retval=0 ;;   compressdoc|!compressdoc) retval=0 ;;
3326     debug|!debug) retval=0 ;;
3327   distcc|!distcc) retval=0 ;;   distcc|!distcc) retval=0 ;;
3328   kernelsrcunpack|!kernelsrcunpack) retval=0 ;;   kernelsrcunpack|!kernelsrcunpack) retval=0 ;;
3329   libtool|!libtool) retval=0 ;;   libtool|!libtool) retval=0 ;;
3330   linuxsymlink|!linuxsymlink) retval=0 ;;   linuxsymlink|!linuxsymlink) retval=0 ;;
3331   pkgbuild|!pkgbuild) retval=0 ;;   pkgbuild|!pkgbuild) retval=0 ;;
3332     pkgdistrotag|!pkgdistrotag) retval=0 ;;
3333   purge|!purge) retval=0 ;;   purge|!purge) retval=0 ;;
3334   qalint|!qalint) retval=0 ;;   qalint|!qalint) retval=0 ;;
3335   regentree|!regentree) retval=0 ;;   regentree|!regentree) retval=0 ;;
3336   resume|!resume) retval=0 ;;   resume|!resume) retval=0 ;;
  stepbystep|!stepbystep) retval=0 ;;  
3337   srcpkgbuild|!srcpkgbuild) retval=0 ;;   srcpkgbuild|!srcpkgbuild) retval=0 ;;
3338   srcpkgtarball|!srcpkgtarball) retval=0 ;;   srcpkgtarball|!srcpkgtarball) retval=0 ;;
3339     static|!static) retval=0 ;;
3340     stepbystep|!stepbystep) retval=0 ;;
3341   strip|!strip) retval=0 ;;   strip|!strip) retval=0 ;;
3342     verbose|!verbose) retval=0 ;;
3343   *) retval=1 ;;   *) retval=1 ;;
3344   esac   esac
3345    
# Line 3326  msetfeature() Line 3368  msetfeature()
3368    
3369   if ! known_mage_feature "${feature}"   if ! known_mage_feature "${feature}"
3370   then   then
3371   [[ ${FVERBOSE} = off ]] || echo "unkown feature ${feature}, ignoring it"   [[ ${FVERBOSE} = off ]] || echo -e "${COLRED}Unknown feature '${feature}', ignoring it${COLDEFAULT}"
3372   return 3   return 3
3373   fi   fi
3374    
# Line 3379  mqueryfeature() Line 3421  mqueryfeature()
3421   fi   fi
3422   done   done
3423   else   else
3424     [[ ${FVERBOSE} = off ]] || echo -e "${COLRED}Unknown feature '${feature}', ignoring it${COLDEFAULT}"
3425   retval=3   retval=3
3426   fi   fi
3427    

Legend:
Removed from v.1620  
changed lines
  Added in v.1658